package com.huimv.farm.damsubsidy.controller;


import cn.hutool.core.date.DateTime;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillSubsidy;
import com.huimv.farm.damsubsidy.service.IBillSubsidyService;
import com.huimv.farm.test.Print;
import com.spire.xls.FileFormat;
import com.spire.xls.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 补贴信息表 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@RestController
@RequestMapping("/bill-subsidy")
@CrossOrigin
public class BillSubsidyController {
    @Autowired
    private IBillSubsidyService iBillSubsidyService;

    @PostMapping("/addApplication")
    public Result addApplication(HttpServletRequest httpServletRequest, @RequestBody BillSubsidy billSubsidy){
        return iBillSubsidyService.addApplication(httpServletRequest,billSubsidy);
    }

    @PostMapping("/saveApplication")
    public Result saveApplication(HttpServletRequest httpServletRequest, @RequestBody BillSubsidy billSubsidy){
        return iBillSubsidyService.saveApplication(httpServletRequest,billSubsidy);
    }

    @Autowired
    private IBillSubsidyService subsidyService;

    @RequestMapping("/list")
    public Result list(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return subsidyService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return subsidyService.listById(httpServletRequest, paramsMap);
    }

    @RequestMapping("/edit")
    public Result edit(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return subsidyService.edit(httpServletRequest, paramsMap);
    }

    @RequestMapping("/appeal")
    public Result appeal(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return subsidyService.appeal(httpServletRequest, paramsMap);
    }
    @PostMapping("/editApplication")
    public Result editApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> parasMap){
        return iBillSubsidyService.editApplication(httpServletRequest,parasMap);
    }

    @PostMapping("/listApplication")
    public Result listApplication(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> parasMap){
        return iBillSubsidyService.listApplication(httpServletRequest,parasMap);
    }

    @PostMapping("/getLast")
    public Result getLast(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> parasMap){
        return iBillSubsidyService.getLast(httpServletRequest,parasMap);
    }

    @PostMapping("/listPcSub")
    public Result listPcSub(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> parasMap){
        return subsidyService.listPcSub(httpServletRequest,parasMap);
    }

    @PostMapping("/listFlow")
    public Result listFlow(@RequestBody Map<String, String> parasMap){
        return iBillSubsidyService.listFlow(parasMap);
    }

    //打印
    @PostMapping("/print")
    public Result print(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> parasMap) throws Exception {
        Integer id=Integer.parseInt(parasMap.get("id"));
        BillSubsidy subsidy = subsidyService.getById(id);
        Print print = new Print();
        String path = print.print(subsidy);

        //加载Excel文档
        Workbook wb = new Workbook();
        wb.loadFromFile(path);

        //调用方法保存为PDF格式
        wb.saveToFile("I://"+subsidy.getFarmerName()+".pdf", FileFormat.PDF);
        return new Result(ResultCode.SUCCESS,"I://"+subsidy.getFarmerName()+".pdf");
    }
}
