package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.BankUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.entity.BaseAnimal;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BillIsolated;
import com.huimv.farm.damsubsidy.entity.BillSubsidy;
import com.huimv.farm.damsubsidy.entity.SysUser;
import com.huimv.farm.damsubsidy.mapper.BaseAnimalMapper;
import com.huimv.farm.damsubsidy.mapper.BillSubsidyMapper;
import com.huimv.farm.damsubsidy.mapper.SysUserMapper;
import com.huimv.farm.damsubsidy.service.IBillSubsidyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 补贴信息表 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BillSubsidyServiceImpl extends ServiceImpl<BillSubsidyMapper, BillSubsidy> implements IBillSubsidyService {

    @Autowired
    private BillSubsidyMapper subsidyMapper;
    @Autowired
    private SysUserMapper sysUserMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String type = paramsMap.get("subsidySch");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }

        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        if (type == null || type == "") {
            queryWrapper.orderByDesc("sub_time");
        } else {
            queryWrapper.eq("subsidy_sch", type).orderByDesc("sub_time");
        }
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
//        List<BillSubsidy> billSubsidies = subsidyMapper.selectList(queryWrapper);

//        JSONArray jsonArray = new JSONArray();
//        for (BillSubsidy billSubsidy : billSubsidies) {
//            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("name", billSubsidy.getSubsidyName());
//            jsonObject.put("date", billSubsidy.getSubTime());
//            jsonObject.put("state", billSubsidy.getSubsidySch());
//            jsonObject.put("id", billSubsidy.getId());
//            jsonArray.add(jsonObject);
//        }
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result listById(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", paramsMap.get("id"));
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        return new Result(ResultCode.SUCCESS, billSubsidy);
    }

    @Override
    public Result edit(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        Integer type = Integer.parseInt(paramsMap.get("type"));
        String id = paramsMap.get("id");
        Integer stateType = Integer.parseInt(paramsMap.get("stateType"));
        //拒绝
        if (type == 1) {
            String refuseReason = paramsMap.get("refuseReason"); //拒绝理由
            if (refuseReason == "" || refuseReason == null) {
                return new Result(ResultCode.FAIL, "拒绝理由不能为空！");
            }
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            billSubsidy.setSubsidySch(2);
            billSubsidy.setAcceptTime(new Date());
            subsidyMapper.insert(billSubsidy);
            return new Result(ResultCode.SUCCESS, "更新状态成功！");
        } else { //受理
            QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("id", id);
            BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
            if (stateType == 1) { //驳回
                String rejectReason = paramsMap.get("rejectReason");
                String workAccptUrl = paramsMap.get("workAccptUrl");
                if (rejectReason == null || rejectReason == "") {
                    return new Result(ResultCode.FAIL, "驳回理由不能为空！");
                }
                if (workAccptUrl == null || workAccptUrl == "") {
                    return new Result(ResultCode.FAIL, "工作验收表不能为空！");
                }
                billSubsidy.setSubsidySch(4);
                billSubsidy.setRejectReason(rejectReason);
                billSubsidy.setWorkAccptUrl(workAccptUrl);
                billSubsidy.setAcceptTime(new Date());
                subsidyMapper.insert(billSubsidy);
                return new Result(ResultCode.SUCCESS, "更新状态成功！");
            } else { //通过
                billSubsidy.setSubsidySch(3);
                billSubsidy.setAcceptTime(new Date());
                String workAccptUrl = paramsMap.get("workAccptUrl");
                if (workAccptUrl == null || workAccptUrl == "") {
                    billSubsidy.setIsPay(0);
                } else {
                    billSubsidy.setWorkAccptUrl(workAccptUrl);
                    billSubsidy.setIsPay(1);
                }
                billSubsidy.setReviewedTime(new Date());
                subsidyMapper.insert(billSubsidy);
                return new Result(ResultCode.SUCCESS, "更新状态成功！");
            }
        }
    }

    @Override
    public Result appeal(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        Integer type = Integer.parseInt(paramsMap.get("type"));
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id", id);
        BillSubsidy billSubsidy = subsidyMapper.selectOne(queryWrapper);
        if (type == 1) { //驳回
            String appeal = paramsMap.get("appeal");
            billSubsidy.setSubsidySch(4);
            billSubsidy.setAppealTime(new Date());
            billSubsidy.setAppeal(appeal);
            subsidyMapper.insert(billSubsidy);
        } else {
            String appeal = paramsMap.get("appeal");
            billSubsidy.setSubsidySch(3);
            billSubsidy.setAppealTime(new Date());
            billSubsidy.setAppeal(appeal);
            subsidyMapper.insert(billSubsidy);
        }
        return new Result(ResultCode.SUCCESS, "更新状态成功！");
    }

    @Resource
    private BaseAnimalMapper baseAnimalMapper;

    @Override
    @Transactional
    public Result addApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        String eartagNo = billSubsidy.getEartagNo();
        String[] eartags = eartagNo.split(",");
        String bankCardId = billSubsidy.getBankCardId();
        if(!(BankUtil.checkBankCard(bankCardId))){
            return new Result(10001,"补贴账号不符合标准!",false);
        }
        for (String eartag : eartags) {
            if (!eartag.contains("-")){
                BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", eartag));
                animal.setIsLoated(1);
                baseAnimalMapper.updateById(animal);
            }else {
                String start = eartag.substring(0, eartag.indexOf("-"));
                String end = eartag.substring(eartag.indexOf("-") + 1);
                String substring = start.substring(0, start.length() - end.length());
                String finish = substring+end;
                List<Integer> numbers = new ArrayList<>();
                for (int i = Integer.parseInt(start); i <= Integer.parseInt(finish); i++) {
                    numbers.add(i);
                }
                for (Integer number : numbers) {
                    String earatgNo = number.toString();
                    BaseAnimal animal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", earatgNo));
                    animal.setIsLoated(1);
                    baseAnimalMapper.updateById(animal);
                }
            }
        }
        billSubsidy.setBankName(BankUtil.getname(bankCardId));
        billSubsidy.setSubsidyName(TokenSign.getUserName(httpServletRequest)+"的补贴申请");
        billSubsidy.setCreateTime(DateTime.now());
        billSubsidy.setCreateUser(TokenSign.getUserName(httpServletRequest));
        billSubsidy.setSubsidySch(0);
        String userName = TokenSign.getUserName(httpServletRequest);
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(subsidy)){
            this.save(billSubsidy);
        }else {
            this.update(billSubsidy,new QueryWrapper<BillSubsidy>().eq("create_user",userName).eq("subsidy_sch",7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result saveApplication(HttpServletRequest httpServletRequest, BillSubsidy billSubsidy) {
        String userName = TokenSign.getUserName(httpServletRequest);
        BillSubsidy subsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("create_user", userName).eq("subsidy_sch", 7));
        billSubsidy.setSubsidySch(7);
        billSubsidy.setCreateUser(userName);
        if (ObjectUtil.isEmpty(subsidy)){
            this.save(billSubsidy);
        }else {
            this.update(billSubsidy,new QueryWrapper<BillSubsidy>().eq("create_user",userName).eq("subsidy_sch",7));
        }
        return Result.SUCCESS();
    }

    @Override
    public Result listPcSub(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String userName = paramsMap.get("userName");
        String date = paramsMap.get("date");
        String pageSize = paramsMap.get("pageSize");
        String pageNum = paramsMap.get("pageNum");
        String type = paramsMap.get("type");
        if (pageSize == null || pageSize == "") {
            pageSize = "10";
        }
        if (pageNum == null || pageNum == "") {
            pageNum = "1";
        }
        if (date != "") {
            date = date + " 00:00:00";
        }
        QueryWrapper<BillSubsidy> queryWrapper = new QueryWrapper<>();
        queryWrapper.ge("sub_time", date).like("farmer_name", userName).eq("subsidy_sch",type);
        Page<BillSubsidy> page = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS, subsidyMapper.selectPage(page, queryWrapper));
    }

    @Override
    public Result editApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        String type = paramsMap.get("type");
        BillSubsidy billSubsidy = this.getById(id);
        //养殖户撤销补贴申请
//        if ("1".equals(type)){
//            billSubsidy.setSubsidySch(8);
//            billSubsidy.setRevokeTime(LocalDate.now());
//            this.updateById(billSubsidy);
//            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().eq("inspection_num", billSubsidy.getInspectionNum()));
//            for (BaseAnimal baseAnimal : baseAnimals) {
//                baseAnimal.setIsLoated(0);
//                baseAnimalMapper.updateById(baseAnimal);
//            }
//            return Result.SUCCESS();
//        }
        if ("1".equals(type)) {
            List<BaseAnimal> baseAnimals = baseAnimalMapper.selectList(new QueryWrapper<BaseAnimal>().eq("inspection_num", billSubsidy.getInspectionNum()));
            for (BaseAnimal baseAnimal : baseAnimals) {
                baseAnimal.setIsLoated(0);
                baseAnimalMapper.updateById(baseAnimal);
            }
            this.removeById(billSubsidy);
            return Result.SUCCESS();
        } else {
//          养殖户申诉不通过补贴申请
            String appeal = paramsMap.get("appeal");
            billSubsidy.setAppeal(appeal);
            billSubsidy.setSubsidySch(5);
            billSubsidy.setAppealTime(new Date());
            if (this.updateById(billSubsidy)) {
                return Result.SUCCESS();
            } else {
                return Result.ERROR();
            }
        }
    }

    @Override
    public Result listApplication(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String pageNum = paramsMap.get("pageNum");
        String pageSize = paramsMap.get("pageSize");
        String subsidySch = paramsMap.get("subsidySch");
//        String startTime = paramsMap.get("startTime");
//        String endTime = paramsMap.get("endTime");
        String userName = TokenSign.getUserName(httpServletRequest);
        Integer userType = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("user_name", userName)).getUserType();

        QueryWrapper<BillSubsidy> subsidyQueryWrapper = new QueryWrapper<>();

        if (userType == 2 || userType == 3) {
            subsidyQueryWrapper.eq("create_user", userName);
        }
//        if (startTime != null) {
//            startTime = startTime + " 00:00:00";
//            subsidyQueryWrapper.ge("create_time",startTime);
//        }
//        if (endTime != null) {
//            endTime = endTime + " 23:59:59";
//            subsidyQueryWrapper.le("create_time",endTime);
//        }
        if (ObjectUtil.isNotEmpty(subsidySch)){
            if (subsidySch.equals("1")){
                subsidyQueryWrapper.eq("subsidy_sch",0);
            }else if (subsidySch.equals("2")){
                subsidyQueryWrapper.eq("subsidy_sch",1).or().eq("subsidy_sch",5);
            }else if (subsidySch.equals("3")){
                subsidyQueryWrapper.eq("subsidy_sch",2).or().eq("subsidy_sch",3).or().eq("subsidy_sch",4);
            }
        }else {
            subsidyQueryWrapper.ne("subsidy_sch",7);
        }
        subsidyQueryWrapper.orderByDesc("create_time");
        Page<BillSubsidy> page = new Page(Integer.parseInt(pageNum),Integer.parseInt(pageSize));
        return new Result(ResultCode.SUCCESS,subsidyMapper.selectPage(page,subsidyQueryWrapper));
    }

    @Override
    public Result getLast(HttpServletRequest httpServletRequest, Map<String, String> parasMap) {
        BillSubsidy billSubsidy = this.getOne(new QueryWrapper<BillSubsidy>().eq("creat_user", TokenSign.getUserName(httpServletRequest)).eq("subsidy_sch", 7));
        if (ObjectUtil.isEmpty(billSubsidy)){
            return new Result(ResultCode.SUCCESS,null);
        }else {
            return new Result(ResultCode.SUCCESS,billSubsidy);
        }
    }

    @Override
    public Result listFlow(Map<String, String> parasMap) {
        String id = parasMap.get("id");
        BillSubsidy billSubsidy = this.getById(id);
        List result = new ArrayList();
        if (billSubsidy.getSubsidySch() == 0){
            result.add("提交申请");
            result.add(billSubsidy.getCreateTime());
            result.add("待受理");
        }else if (billSubsidy.getSubsidySch() == 1){
            result.add("提交申请");
            result.add(billSubsidy.getCreateTime());
            result.add("已受理");
            result.add(billSubsidy.getAcceptTime());
            result.add("审核中");
        }else if (billSubsidy.getSubsidySch() == 2){

        }
        return null;
    }
}
